%global mpi_list mpich openmpi
%ifarch loongarch64
%define debug_package %{nil}
%endif

%global quad 0
%ifarch x86_64
%global quad 1
%endif

Summary:        A Fast Fourier Transform library
Name:           fftw
Version:        3.3.10
Release:        8%{?dist}
License:        GPLv2+
URL:            http://www.fftw.org
Source0:        http://www.fftw.org/fftw-%{version}.tar.gz
BuildRequires:  make gcc-gfortran
BuildRequires:  time perl-interpreter mpich-devel nss-myhostname openmpi-devel environment-modules openssh-clients
%ifarch loongarch64
BuildRequires:  automake libtool
%endif

%description
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.


%package libs
Summary:        FFTW run-time library
Provides:       fftw3 = %{version}-%{release}
Requires:       fftw-libs-single = %{version}-%{release}
Requires:       fftw-libs-double = %{version}-%{release}
Requires:       fftw-libs-long = %{version}-%{release}
%if %{quad}
Requires:       fftw-libs-quad = %{version}-%{release}
%endif

%description libs
This is a dummy package package, pulling in the individual FFTW
run-time libraries.


%package devel
Summary:        Headers, libraries and docs for the FFTW library
Requires:       pkgconfig
Requires:       fftw = %{version}-%{release}
Requires:       fftw-libs = %{version}-%{release}
Provides:       fftw3-devel = %{version}-%{release}
Provides:       fftw3-devel = %{version}-%{release}

%description devel
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.
This package contains header files and development libraries needed to
develop programs using the FFTW fast Fourier transform library.


%package libs-double
Summary:        FFTW library, double precision

%description libs-double
This package contains the FFTW library compiled in double precision.


%package libs-single
Summary:        FFTW library, single precision

%description libs-single
This package contains the FFTW library compiled in single precision.


%package libs-long
Summary:        FFTW library, long double precision 

%description libs-long
This package contains the FFTW library compiled in long double
precision.


%if %{quad}
%package libs-quad
Summary:        FFTW library, quadruple

%description libs-quad
This package contains the FFTW library compiled in quadruple
precision.
%endif


%package        static
Summary:        Static versions of the FFTW libraries
Requires:       fftw-devel = %{version}-%{release}
Provides:       fftw3-static = %{version}-%{release}
Provides:       fftw3-static = %{version}-%{release}

%description static
The fftw-static package contains the statically linkable version of
the FFTW fast Fourier transform library.


%package mpich-libs
Summary:        FFTW MPICH run-time library
Provides:       fftw3-mpich = %{version}-%{release}
Requires:       fftw-mpich-libs-single = %{version}-%{release}
Requires:       fftw-mpich-libs-double = %{version}-%{release}
Requires:       fftw-mpich-libs-long = %{version}-%{release}

%description mpich-libs
This is a dummy package package, pulling in the individual FFTW
MPICH run-time libraries.


%package mpich-devel
Summary:        Headers, libraries and docs for the FFTW MPICH library
Requires:       mpich-devel
Requires:       pkgconfig
Requires:       fftw-devel = %{version}-%{release}
Requires:       fftw-mpich-libs = %{version}-%{release}
Provides:       fftw3-mpich-devel = %{version}-%{release}
Provides:       fftw3-mpich-devel = %{version}-%{release}

%description mpich-devel
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.
This package contains header files and development libraries needed to
develop programs using the FFTW fast Fourier transform library for MPICH.


%package mpich-libs-double
Summary:        FFTW MPICH library, double precision
Requires:       fftw-libs-double = %{version}-%{release}

%description mpich-libs-double
This package contains the FFTW MPICH library compiled in double precision.


%package mpich-libs-single
Summary:        FFTW MPICH library, single precision
Requires:       fftw-libs-single = %{version}-%{release}

%description mpich-libs-single
This package contains the FFTW MPICH library compiled in single precision.


%package mpich-libs-long
Summary:        FFTW MPICH library, long double precision 
Requires:       fftw-libs-long = %{version}-%{release}

%description mpich-libs-long
This package contains the FFTW MPICH library compiled in long double
precision.


%package        mpich-static
Summary:        Static versions of the FFTW MPICH libraries
Requires:       fftw-mpich-devel = %{version}-%{release}
Requires:       fftw-static = %{version}-%{release}
Provides:       fftw3-mpich-static = %{version}-%{release}
Provides:       fftw3-mpich-static = %{version}-%{release}

%description mpich-static
The fftw-mpich-static package contains the statically linkable version of
the FFTW fast Fourier transform library for MPICh.


%package openmpi-libs
Summary:        FFTW OpenMPI run-time library
Provides:       fftw3-openmpi = %{version}-%{release}
Requires:       fftw-openmpi-libs-single = %{version}-%{release}
Requires:       fftw-openmpi-libs-double = %{version}-%{release}
Requires:       fftw-openmpi-libs-long = %{version}-%{release}

%description openmpi-libs
This is a dummy package package, pulling in the individual FFTW
OpenMPI run-time libraries.


%package openmpi-devel
Summary:        Headers, libraries and docs for the FFTW OpenMPI library
Requires:       openmpi-devel
Requires:       pkgconfig
Requires:       fftw-devel = %{version}-%{release}
Requires:       fftw-openmpi-libs = %{version}-%{release}
Provides:       fftw3-openmpi-devel = %{version}-%{release}
Provides:       fftw3-openmpi-devel = %{version}-%{release}

%description openmpi-devel
FFTW is a C subroutine library for computing the Discrete Fourier
Transform (DFT) in one or more dimensions, of both real and complex
data, and of arbitrary input size.
This package contains header files and development libraries needed to
develop programs using the FFTW fast Fourier transform library for OpenMPI.


%package openmpi-libs-double
Summary:        FFTW OpenMPI library, double precision
Requires:       fftw-libs-double = %{version}-%{release}

%description openmpi-libs-double
This package contains the FFTW OpenMPI library compiled in double precision.


%package openmpi-libs-single
Summary:        FFTW OpenMPI library, single precision
Requires:       fftw-libs-single = %{version}-%{release}

%description openmpi-libs-single
This package contains the FFTW OpenMPI library compiled in single precision.


%package openmpi-libs-long
Summary:        FFTW OpenMPI library, long double precision 
Requires:       fftw-libs-long = %{version}-%{release}

%description openmpi-libs-long
This package contains the FFTW OpenMPI library compiled in long double
precision.


%package        openmpi-static
Summary:        Static versions of the FFTW OpenMPI libraries
Requires:       fftw-openmpi-devel = %{version}-%{release}
Requires:       fftw-static = %{version}-%{release}
Provides:       fftw3-openmpi-static = %{version}-%{release}
Provides:       fftw3-openmpi-static = %{version}-%{release}

%description openmpi-static
The fftw-openmpi-static package contains the statically linkable version of
the FFTW fast Fourier transform library for MPICh.


%package doc
Summary:        FFTW library manual
BuildArch:      noarch

%description doc
This package contains the manual for the FFTW fast Fourier transform
library.


%prep
%autosetup

%build
%ifarch loongarch64
autoreconf -fiv
%endif
. /etc/profile.d/modules.sh
export F77=gfortran
BASEFLAGS="--enable-shared --disable-dependency-tracking --enable-threads"
BASEFLAGS+=" --enable-openmp"

prec_name[0]=single
prec_name[1]=double
prec_name[2]=long
prec_name[3]=quad

prec_flags[0]=--enable-single
prec_flags[1]=--enable-double
prec_flags[2]=--enable-long-double
prec_flags[3]=--enable-quad-precision

%ifarch x86_64
for ((i=0; i<2; i++)) ; do
    prec_flags[i]+=" --enable-sse2 --enable-avx"
done
%endif

%if %{quad}
for ((iprec=0; iprec<4; iprec++)) ; do
%else
for ((iprec=0; iprec<3; iprec++)) ; do
%endif
    mkdir ${prec_name[iprec]}${ver_name[iver]}
    cd ${prec_name[iprec]}${ver_name[iver]}
    ln -s ../configure .
    %{configure} ${BASEFLAGS} ${prec_flags[iprec]}
    sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
    sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
    %make_build
    cd ..
done

for mpi in %{mpi_list} ; do
    module load mpi/${mpi}-%{_arch}
    for((iprec=0;iprec<3;iprec++)) ; do
        mkdir ${mpi}-${prec_name[iprec]}${ver_name[iver]}
        cd ${mpi}-${prec_name[iprec]}${ver_name[iver]}
        ln -s ../configure .
        export CC=mpicc
        %{configure} ${BASEFLAGS} ${prec_flags[iprec]} \
            --enable-mpi \
            --libdir=%{_libdir}/$mpi/lib \
            --bindir=%{_libdir}/$mpi/bin \
            --sbindir=%{_libdir}/$mpi/sbin \
            --includedir=%{_includedir}/$mpi-%{_arch} \
            --mandir=%{_libdir}/$mpi/share/man
        make %{?_smp_mflags}
        cd ..
    done
    module unload mpi/${mpi}-%{_arch}
done


%install
source /etc/profile.d/modules.sh

%if %{quad}
for ver in single double long quad ; do
%else
for ver in single double long ; do
%endif
    make -C $ver install DESTDIR=%{buildroot}
done

for mpi in %{mpi_list} ; do
    module load mpi/${mpi}-%{_arch}
    for ver in single double long ; do
        make -C ${mpi}-${ver} install DESTDIR=%{buildroot}
        find %{buildroot}%{_libdir}/${mpi}/lib -name libfftw\* -a \! -name \*_mpi.\* -delete
        rm -r %{buildroot}%{_libdir}/${mpi}/{bin,share}
    done
    module unload mpi/${mpi}-%{_arch}
done

rm -f %{buildroot}%{_infodir}/dir
find %{buildroot} -name \*.la -delete


%check
%ifnarch loongarch64
. /etc/profile.d/modules.sh
bdir=$(pwd)
%if %{quad}
for ver in single double long quad ; do
%else
for ver in single double long ; do
%endif
    export LD_LIBRARY_PATH=$bdir/$ver/.libs:$bdir/$ver/threads/.libs
    make %{?_smp_mflags} -C $ver check
done

for mpi in %{mpi_list} ; do
    module load mpi/${mpi}-%{_arch}
    for ver in single double long ; do
        export LD_LIBRARY_PATH=$bdir/$ver/.libs:$bdir/$ver/threads/.libs
        make %{?_smp_mflags} -C ${mpi}-${ver}/mpi check
    done
    module unload mpi/${mpi}-%{_arch}
done
%endif


%files
%{_mandir}/man1/fftw*.1*
%{_bindir}/fftw*-wisdom*

%files libs

%files libs-single
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/libfftw3f.so.*
%{_libdir}/libfftw3f_threads.so.*
%{_libdir}/libfftw3f_omp.so.*

%files libs-double
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/libfftw3.so.*
%{_libdir}/libfftw3_threads.so.*
%{_libdir}/libfftw3_omp.so.*

%files libs-long
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/libfftw3l.so.*
%{_libdir}/libfftw3l_threads.so.*
%{_libdir}/libfftw3l_omp.so.*

%if %{quad}
%files libs-quad
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/libfftw3q.so.*
%{_libdir}/libfftw3q_threads.so.*
%{_libdir}/libfftw3q_omp.so.*
%endif

%files devel
%doc doc/FAQ/fftw-faq.html/
%doc %{_infodir}/fftw3.info*
%{_includedir}/fftw3*
%dir %{_libdir}/cmake/fftw3/
%{_libdir}/cmake/fftw3/*.cmake
%{_libdir}/pkgconfig/fftw3*.pc
%{_libdir}/libfftw3*.so

%files static
%{_libdir}/libfftw3*.a

%files doc
%doc doc/*.pdf doc/html/

%files mpich-libs

%files mpich-libs-single
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/mpich/lib/libfftw3f_mpi.so.*

%files mpich-libs-double
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/mpich/lib/libfftw3_mpi.so.*

%files mpich-libs-long
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/mpich/lib/libfftw3l_mpi.so.*

%files mpich-devel
%doc doc/FAQ/fftw-faq.html/
%{_includedir}/mpich-%{_arch}
%dir %{_libdir}/mpich/lib/cmake/fftw3/
%{_libdir}/mpich/lib/cmake/fftw3/*.cmake
%{_libdir}/mpich/lib/pkgconfig/fftw3*.pc
%{_libdir}/mpich/lib/libfftw3*.so

%files mpich-static
%{_libdir}/mpich/lib/libfftw3*.a

%files openmpi-libs

%files openmpi-libs-single
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/openmpi/lib/libfftw3f_mpi.so.*

%files openmpi-libs-double
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/openmpi/lib/libfftw3_mpi.so.*

%files openmpi-libs-long
%license COPYING COPYRIGHT
%doc AUTHORS ChangeLog NEWS README* TODO
%{_libdir}/openmpi/lib/libfftw3l_mpi.so.*

%files openmpi-devel
%doc doc/FAQ/fftw-faq.html/
%{_includedir}/openmpi-%{_arch}
%dir %{_libdir}/openmpi/lib/cmake/fftw3/
%{_libdir}/openmpi/lib/cmake/fftw3/*.cmake
%{_libdir}/openmpi/lib/pkgconfig/fftw3*.pc
%{_libdir}/openmpi/lib/libfftw3*.so

%files openmpi-static
%{_libdir}/openmpi/lib/libfftw3*.a


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.10-8
- Rebuilt for loongarch release

* Thu Jul 25 2024 Pengda Dou <doupengda@loongson> - 3.3.10-7
- [Type] other
- [DESC] fix empty file debugsourcefiles.list error for loongarch64

* Mon Jul 15 2024 Pengda Dou <doupengda@loongson> - 3.3.10-6
- [Type] other
- [DESC] fix build error for loongarch64

* Tue Mar 19 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 3.3.10-5
- add update config.guess and config.sub for loongarch64

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.10-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.10-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.10-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Nov 17 2022 Miaojun Dong <zoedong@tencent.com> - 3.3.10-1
- Initial build
